Attribute VB_Name = "TestHeapSortCollection"
Option Explicit

'--- Sample for using the SortCollection function -----------------------

Public Sub Sample1()
   Dim c As New Collection
   c.Add "Pear"
   c.Add "Apple"
   c.Add "Cherry"
   c.Add "Prune"
   c.Add "Peach"
   Dim c2 As Collection
   Set c2 = SortCollection(c)
   Dim s
   For Each s In c2
      Debug.Print s
      Next
   End Sub

'--- Test functions -----------------------------------------------------

' Test routine for the SortCollection routine.
' Uses random numbers to verify the sort algorithm.
Public Sub TestSortCollection()
   Debug.Print "Start"
   Dim i
   For i = 1 To 1000
      Dim c As Collection: Set c = GenerateCollectionWithRandomValues()
      Dim c2 As Collection: Set c2 = SortCollection(c)
      VerifyCollectionIsSorted c2
      Next
   Debug.Print "OK"
   End Sub

Private Function GenerateCollectionWithRandomValues() As Collection
   Dim n As Long: n = 1 + Rnd * 100
   Dim c As New Collection
   Dim i As Long
   For i = 1 To n
      c.Add CLng(Rnd * 1000)
      Next
   Set GenerateCollectionWithRandomValues = c
   End Function

Private Sub VerifyCollectionIsSorted(ByVal c As Collection)
   Dim i As Long
   For i = 1 To c.Count - 1
      If c.Item(i) > c.Item(i + 1) Then
         Err.Raise vbObjectError, , "Collection is not sorted!"
         End If
      Next
   End Sub

